xquery version "3.0";

declare namespace trigger = "http://exist-db.org/xquery/trigger";

import module namespace transform = "http://exist-db.org/xquery/transform";
import module namespace validation = "http://exist-db.org/xquery/validation";
import module namespace xmldb = "http://exist-db.org/xquery/xmldb";
import module namespace xslfo = "http://exist-db.org/xquery/xslfo";


declare function trigger:after-move-collection($uri as xs:anyURI, $new-uri as xs:anyURI) {
    
    let $null := util:log("info", ("********* ADAM ASSEMBLY TRIGGER CALLED *********", $uri, $new-uri))
    
    (: 1. Assemble a PDF :)

    let $source-resource := xmldb:get-child-resources($new-uri)[ends-with(., ".xml")][1]
    let $resource := $new-uri || "/" || $source-resource

        let $fo := transform:transform(
        	doc($source-resource),
        	doc("/db/publishing/validation/docbook-fo.xslt"), ())
        return
            let $pdf := xslfo:render($fo, "application/pdf", ())
            return
                xmldb:store($new-uri, $resource || ".pdf", $fo, "application/pdf")
};


(: main: do nothing - this is a trigger :)
()